##############################################################################
########## Debugging and Utility Macros/Variables Defined Below ##############
##############################################################################
# Some useful definitions for special characters
#newline (linefeed) character
define newline


endef

comma:= ,
empty:=
space:= $(empty) $(empty)
tab:= $(empty)	$(empty)
dollar:=$$
hash:=\#
bkslash:=\\
t:=$(tab)
n:=$(newline)
_:=$(empty)
s:=$(space)
k:=$(bkslash)
h:=$(hash)

# MKDIR: A function to make a directory.
#      Usage: $(call MKDIR,PATH_TO_DIR)
MKDIR = @[[ -e $(1) ]] || mkdir -p $(1) &> /dev/null

# MAKE_OUTDIR: A macro to use in recipes. 
#    It simply makes the parent directory of the target file.
#    Usage: $(MAKE_OUTDIR)
MAKE_OUTDIR = $(call MKDIR,$(@D))

############# Debugging ######################################################
# Show information about defined variables
#############################################################################
# fShowVar - Show information about a single variable
# Usage: $(call fShowVar,var_name)
fShowVar=$(info $(call fGetVarInfo,$(1)))
  fGetVarInfo=$(1)$(SV_SEP)Source: $(origin $(1))$(SV_SEP)Define: $(value $(1))$(SV_SEP)Value : $($(filter-out fGetVar% fShowVar%,$(1)))
  SV_SEP=$s   # Separator between variable information fields in fShowVar/fGetVar

# fShowVarList - Show information about a each variable in a list of whitespace-separated names
# Usage: $(call fShowVarList,variable_names)
fShowVarList=$(info $(call fGetVarList,$(1)))
fGetVarList=$(eval SV_SEP=$$n    )$(foreach var,$(filter-out dfGetVar% fdShowVar%,$(1)),$n  $(call fGetVarInfo,$(var)))

###################################################################
# Text processing functions
#############################################################################
# Converts a list of space-separated values into a list newline-separated list (i.e. one value per line)
# Usage: $(call fSpacesToLines,$(list))
fSpacesToLines=$(subst $s,$n,$(1))
#fShowVarListOld=$(foreach var,$(1),\#    $(call fShowVar,$(var),$(newline)\#       ,$(tab))$(newline))\#

showallvars:
	$(eval F=1)
	#$(info All Vars: $(call fGetVarList,banana $(.VARIABLES) orange))
	$(info F=$(F))

$(info F=$(F))